<?php

declare(strict_types=1);

namespace App\Repository;

final class TblCursoUsuarioRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblCursoUsuarioId): object
    {
        $query = 'SELECT * FROM `TblCursoUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblCursoUsuarioId);
        $statement->execute();
        $TblCursoUsuario = $statement->fetchObject();
        if (! $TblCursoUsuario) {
            throw new \Exception('TblCursoUsuario not found.', 404);
        }

        return $TblCursoUsuario;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblCursoUsuario` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblCursoUsuario): object
    {
        $query = 'INSERT INTO `TblCursoUsuario` (`IdCurso`, `FechaInicio`, `FechaFin`, `IdUsuario`, `DiasAdicionales`, `Calificacion`, `IdValorTipo`, `CalificarExperiencia`, 
        `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:IdCurso, :FechaInicio, :FechaFin, :IdUsuario, :DiasAdicionales, :Calificacion, :IdValorTipo, :CalificarExperiencia, 
        :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblCursoUsuario->id);
//         $statement->bindParam('fecha', $TblCursoUsuario->fecha);
        $statement->bindParam('IdCurso', $TblCursoUsuario->IdCurso);
        $statement->bindParam('FechaInicio', $TblCursoUsuario->FechaInicio);
        $statement->bindParam('FechaFin', $TblCursoUsuario->FechaFin);
        $statement->bindParam('IdUsuario', $TblCursoUsuario->IdUsuario);
        $statement->bindParam('DiasAdicionales', $TblCursoUsuario->DiasAdicionales);
        $statement->bindParam('Calificacion', $TblCursoUsuario->Calificacion);
        $statement->bindParam('IdValorTipo', $TblCursoUsuario->IdValorTipo);
        $statement->bindParam('CalificarExperiencia', $TblCursoUsuario->CalificarExperiencia);
        $statement->bindParam('field1', $TblCursoUsuario->field1);
        $statement->bindParam('field2', $TblCursoUsuario->field2);
        $statement->bindParam('field3', $TblCursoUsuario->field3);
        $statement->bindParam('field4', $TblCursoUsuario->field4);
        $statement->bindParam('field5', $TblCursoUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblCursoUsuario, object $data): object
    {
        if (isset($data->fecha)) {
            $TblCursoUsuario->fecha = $data->fecha;
        }
        if (isset($data->IdCurso)) {
            $TblCursoUsuario->IdCurso = $data->IdCurso;
        }
        if (isset($data->FechaInicio)) {
            $TblCursoUsuario->FechaInicio = $data->FechaInicio;
        }
        if (isset($data->FechaFin)) {
            $TblCursoUsuario->FechaFin = $data->FechaFin;
        }
        if (isset($data->IdUsuario)) {
            $TblCursoUsuario->IdUsuario = $data->IdUsuario;
        }
        if (isset($data->DiasAdicionales)) {
            $TblCursoUsuario->DiasAdicionales = $data->DiasAdicionales;
        }
        if (isset($data->Calificacion)) {
            $TblCursoUsuario->Calificacion = $data->Calificacion;
        }
        if (isset($data->IdValorTipo)) {
            $TblCursoUsuario->IdValorTipo = $data->IdValorTipo;
        }
        if (isset($data->CalificarExperiencia)) {
            $TblCursoUsuario->CalificarExperiencia = $data->CalificarExperiencia;
        }
        if (isset($data->field1)) {
            $TblCursoUsuario->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblCursoUsuario->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblCursoUsuario->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblCursoUsuario->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblCursoUsuario->field5 = $data->field5;
        }

        $query = 'UPDATE `TblCursoUsuario` SET `fecha` = :fecha, `IdCurso` = :IdCurso, `FechaInicio` = :FechaInicio, `FechaFin` = :FechaFin, `IdUsuario` = :IdUsuario, `DiasAdicionales` = :DiasAdicionales, `Calificacion` = :Calificacion, `IdValorTipo` = :IdValorTipo, `CalificarExperiencia` = :CalificarExperiencia, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblCursoUsuario->id);
        $statement->bindParam('fecha', $TblCursoUsuario->fecha);
        $statement->bindParam('IdCurso', $TblCursoUsuario->IdCurso);
        $statement->bindParam('FechaInicio', $TblCursoUsuario->FechaInicio);
        $statement->bindParam('FechaFin', $TblCursoUsuario->FechaFin);
        $statement->bindParam('IdUsuario', $TblCursoUsuario->IdUsuario);
        $statement->bindParam('DiasAdicionales', $TblCursoUsuario->DiasAdicionales);
        $statement->bindParam('Calificacion', $TblCursoUsuario->Calificacion);
        $statement->bindParam('IdValorTipo', $TblCursoUsuario->IdValorTipo);
        $statement->bindParam('CalificarExperiencia', $TblCursoUsuario->CalificarExperiencia);
        $statement->bindParam('field1', $TblCursoUsuario->field1);
        $statement->bindParam('field2', $TblCursoUsuario->field2);
        $statement->bindParam('field3', $TblCursoUsuario->field3);
        $statement->bindParam('field4', $TblCursoUsuario->field4);
        $statement->bindParam('field5', $TblCursoUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblCursoUsuario->id);
    }

    public function delete(int $TblCursoUsuarioId): void
    {
        $query = 'DELETE FROM `TblCursoUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblCursoUsuarioId);
        $statement->execute();
    }
}
